'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateJsonPath = exports.isAJson = exports.isAJsonPath = undefined;

var _isValidPath = require('is-valid-path');

var _isValidPath2 = _interopRequireDefault(_isValidPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var INVALID_PATH_ERROR = 'Invalid path';
var INVALID_JSON_PATH_ERROR = 'Not a .json file';

var isAJsonPath = exports.isAJsonPath = function isAJsonPath(path) {
  return (/\.json$/.test(path)
  );
};

// FIXME: JSON.parse is so slow
//        we could access the first key of the object
var isAJson = exports.isAJson = function isAJson(json) {
  try {
    JSON.parse(json);
  } catch (e) {
    return false;
  }
  return true;
};

var validateJsonPath = exports.validateJsonPath = function validateJsonPath(jsonPath) {
  if (!(0, _isValidPath2.default)(jsonPath)) {
    throw Error(INVALID_PATH_ERROR);
  }

  if (!isAJsonPath(jsonPath)) {
    throw Error(INVALID_JSON_PATH_ERROR);
  }
};